<?php
// $Id$

/**
 * @file
 * Auto shops admin page callbacks
 */

function auto_shops_dashboard() {
  auto_shops_sync_node_table();
  //auto_shops_verify_statuses();
  //db_query("DELETE FROM {auto_shops}");
  //db_query("UPDATE {auto_shops} SET status='node_created'");
  //db_query("ALTER TABLE {auto_shops} ADD COLUMN comments VARCHAR(255) NOT NULL");
  //db_query("INSERT INTO {auto_shops} (url, title, location, nid, status) VALUES ('http://drupal.org', 'drupal', 'uk', 6164, 'node_created')");
  //auto_shops_process_screen_retrieved(1, 6164);
  $output = "";
  $output .= drupal_get_form('auto_shops_settings_form') .'<br />';
  $initial = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = '' AND nid = 0"));
  $node_created = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'node_created'"));
  $screen_requested = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'screen_requested'"));
  $screen_retrieved = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'screen_retrieved'"));
  $page_retrieved = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'page_retrieved'"));
  $page_sanitized = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'page_sanitized'"));
  $page_analyzed = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'page_analyzed' AND authorization NOT LIKE 'pending_%'"));
  $waiting = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'page_analyzed' AND authorization LIKE 'pending_%'"));
  $blacklisted = db_result(db_query("SELECT COUNT(*) FROM {auto_shops} WHERE status = 'blacklisted'"));
  $total = db_result(db_query("SELECT COUNT(*) FROM {auto_shops}"));
  $output .= "<strong> $initial </strong> shops awaiting creation ". l('[create]', 'auto_shops/initial') .'<br />';
  $output .= "<strong> $node_created </strong> shops awaiting screenshot requesting ". l('[request]', 'auto_shops/node_created') .' '. l('[force]', 'auto_shops/node_created/force') .'<br />';
  $output .= "<strong> $screen_requested </strong> shops awaiting screenshot retrieval ". l('[retrieve]', 'auto_shops/screen_requested') .' '. l('[force]', 'auto_shops/screen_requested/force') .'<br />';
  $output .= "<strong> $screen_retrieved </strong> shops awaiting page retrieval ". l('[retrieve]', 'auto_shops/screen_retrieved') .' '. l('[force]', 'auto_shops/screen_retrieved/force') .'<br />';
  $output .= "<strong> $page_retrieved </strong> shops awaiting page sanitizing ". l('[sanitize]', 'auto_shops/page_retrieved') .' '. l('[force]', 'auto_shops/page_retrieved/force') .'<br />';
  $output .= "<strong> $page_sanitized </strong> shops awaiting page analysis ". l('[analyze]', 'auto_shops/page_sanitized') .' '. l('[force]', 'auto_shops/page_sanitized/force') .'<br />';
  $output .= "<strong> $page_analyzed </strong> shops done and approved<br />";
  $output .= "<strong> $waiting </strong> shops done, but waiting approval<br />";
  $output .= "<strong> $blacklisted </strong> shops blacklisted<br />";
  $output .= "<strong> $total </strong> shops total<br />";
  $output .= l('Verify these statuses (not recommended unless corruption is possible)', 'auto_shops/verify');
  return $output;
}

function auto_shops_more_settings() {
  $form = array();
  
  $form['auto_shops_dummy_screenshot'] = array(
    '#type' => 'textfield',
    '#title' => t('Dummy screenshot file path'),
    '#description' => t('Enter a local drupal path (for example: sites/default/files/dummy_screenshot.jpg)'),
    '#default_value' => variable_get('auto_shops_dummy_screenshot', 'sites/default/files/dummy_screenshot.jpg'),
    '#size' => 60,
    '#maxlength' => 128,
    '#required' => TRUE,
  );
  
  return system_settings_form($form);
}

function auto_shops_settings_form() {
  $form = array();
  
  $form['process_num'] = array(
    '#type' => 'textfield',
    '#title' => t('Number of urls to process each execution'),
    '#default_value' => variable_get('auto_shops_process_count', 1),
    '#size' => 10,
    '#maxlength' => 10,
    '#required' => TRUE,
  );
  $form['lower'] = array(
    '#type' => 'textfield',
    '#title' => t('Lower bound (nid) for verifying shops'),
    '#default_value' => variable_get('auto_shops_lower', 0),
    '#size' => 10,
    '#maxlength' => 10,
    '#required' => TRUE,
  );
  $form['process_date'] = array(
    '#type' => 'textfield',
    '#title' => t('If forced, process shops older than this unix timestamp'),
    '#description' => 'The value '. time()*2 .' (arbitrary future time) can be used to force processing of all shops. Otherwise, the current unix time is '. time() .' and a reduction in this can be specified to process outdated shops. Only applies when forcing a processing stage.',
    '#default_value' => variable_get('auto_shops_process_date', 12345678900),
    '#size' => 20,
    '#maxlength' => 20,
    '#required' => TRUE,
  );
  
  $form['submit'] = array('#type' => 'submit', '#value' => t('Save'));
  
  return $form;
}

function auto_shops_settings_form_submit($form, &$form_state)  {
  if (is_numeric($form_state['values']['process_num'])) {
    variable_set('auto_shops_process_count', $form_state['values']['process_num']);
  }
  if (is_numeric($form_state['values']['process_date'])) {
    variable_set('auto_shops_process_date', $form_state['values']['process_date']);
  }
  variable_set('auto_shops_lower', $form_state['values']['lower']);
}

/**
 * Callback function for processing a stage (forced)
 */
function auto_shops_processor_force($status) {
  auto_shops_processor($status, TRUE);
}

/**
 * Callback function for processing a single node one stage
 */
function auto_shops_processor_single_node($nid, $status) {
  watchdog('auto_shops', t('Beginning processing of single node (nid: !nid) at stage: !stage', array('!stage' => $status, '!nid' => $nid)));
  switch ($status) {
    case 'node_created':
      auto_shops_process_node_created(-1, $nid);
      break;
    case 'screen_retrieved':
      auto_shops_process_screen_retrieved(-1, $nid);
      break;
    case 'page_retrieved':
      auto_shops_process_page_retrieved(-1, $nid);
      break;
    case 'page_sanitized':
      auto_shops_process_page_sanitized(-1, $nid);
      break;
    case 'blacklist':
      // blacklist this url by marking its status blacklisted and unpublishing the node
      db_query("UPDATE {auto_shops} SET status='blacklisted', modified=%d WHERE nid=%d", time(), $nid);
      $node = node_load($nid);
      $node->status = 0;
      $node = node_submit($node);
      node_save($node);
      drupal_set_message("URL blacklisted. Node is now unpublished.");
      break;
    case 'unblacklist':
      // unblacklist this url by marking its status not blacklisted
      db_query("UPDATE {auto_shops} SET status='node_created', modified=%d WHERE nid=%d", time(), $nid);
      drupal_set_message("URL unblacklisted. Node will be processed and published.");
      break;
    case 'approve':
      // approve this url by removing the pending authorization and publishing the node
      $authorization = db_result(db_query("SELECT authorization FROM {auto_shops} WHERE nid=%d", $nid));
      $auth = str_replace('pending_', '', $authorization); 
      db_query("UPDATE {auto_shops} SET authorization='%s', modified=%d WHERE nid=%d", $auth, time(), $nid);
      $node = node_load($nid);
      $node->status = 1;
      $node = node_submit($node);
      node_save($node);
      drupal_set_message("Pending authorization removed. Node is now published.");
      break;
    case 'unapprove':
      // unapprove this url by adding the pending authorization and unpublishing the node
      $authorization = db_result(db_query("SELECT authorization FROM {auto_shops} WHERE nid=%d", $nid));
      $auth = 'pending_'. $authorization; 
      db_query("UPDATE {auto_shops} SET authorization='%s', modified=%d WHERE nid=%d", $auth, time(), $nid);
      $node = node_load($nid);
      $node->status = 0;
      $node = node_submit($node);
      node_save($node);
      drupal_set_message("Pending authorization added. Node is now unpublished.");
      break;
  }
  watchdog('auto_shops', t('Completed processing of single node (nid: !nid) at stage: !stage', array('!stage' => $status, '!nid' => $nid)));
  drupal_goto('node/'. $nid);
}

/**
 * Callback function for processing a stage
 */
function auto_shops_processor($status, $force = FALSE) {
  watchdog('auto_shops', t('Beginning processing of stage: !stage', array('!stage' => $status)));
  switch ($status) {
    case 'initial':
      auto_shops_process_initial();
      break;
    case 'node_created':
      ($force) ? auto_shops_process_node_created(variable_get('auto_shops_process_date', 12345678900)) : auto_shops_process_node_created();
      break;
    case 'screen_requested':
      ($force) ? auto_shops_process_node_created(variable_get('auto_shops_process_date', 12345678900)) : auto_shops_process_node_created();
      break;
    case 'screen_retrieved':
      ($force) ? auto_shops_process_screen_retrieved(variable_get('auto_shops_process_date', 12345678900)) : auto_shops_process_screen_retrieved();
      break;
    case 'page_retrieved':
      ($force) ? auto_shops_process_page_retrieved(variable_get('auto_shops_process_date', 12345678900)) : auto_shops_process_page_retrieved();
      break;
    case 'page_sanitized':
      ($force) ? auto_shops_process_page_sanitized(variable_get('auto_shops_process_date', 12345678900)) : auto_shops_process_page_sanitized();
      break;
  }
  watchdog('auto_shops', t('Completed processing of stage: !stage', array('!stage' => $status)));
  drupal_goto('admin/build/auto_shops');
}

/**
 * create node
 * 
 * @param $url specify url to manually process only this url. Node should be undefined.
 */
function auto_shops_process_initial($url = '', $uid = 1) {
  module_load_include('inc', 'node', 'node.pages');
  if (strlen($url) > 0) {
    $urls = db_query("SELECT url, title FROM {auto_shops} WHERE nid = 0 AND url = '%s'", $url);
  }
  else {
    $urls = db_query("SELECT url, title FROM {auto_shops} WHERE nid = 0 AND status = '' LIMIT %d", variable_get('auto_shops_process_count', 1));
  }
  
  while ($url = db_fetch_object($urls)) {
    $node->type = 'store';
    node_object_prepare($node);
    $node->uid = $uid;
    $node->title = $url->title;
    $node->body = "";
    $node->teaser = "";
    $node->filter = variable_get('filter_default_format', 1);
    $node->format = FILTER_FORMAT_DEFAULT;
    $node->language = '';
    $node->revision = 0;
    $node->promote = 0;
    $node->created = time();
    $node->comment= 0;
    $node->status = 0;
    
    $node->field_url[0]['url'] = $url->url;
    
    $node = node_submit($node);
    node_save($node);
    $nid = $node->nid;
    unset($node);
    
    db_query("UPDATE {auto_shops} SET nid=%d, status='%s', modified=%d WHERE url='%s'", $nid, 'node_created', time(), $url->url);
  }
  
  // omit this message if processing just a specific url
  if (strlen($url) == 0) {
    drupal_set_message('initial processing executed');
  }
}

/**
 * handle requesting and storing locally screenshot
 * 
 * @param $force unix timestamp of date below which shops should be refreshed
 * @param $nid nid of specific shop to process
 */
function auto_shops_process_node_created($force = -1, $nid = 0) {
  if ($nid != 0) {
    $urls = db_query("SELECT url, nid, status, authorization FROM {auto_shops} WHERE nid = %d", $nid);
  }
  elseif ($force > 0) {
    $urls = db_query("SELECT url, nid, status, authorization FROM {auto_shops} WHERE status != '' AND status != 'blacklisted' AND modified <= %d ORDER BY modified ASC LIMIT %d", $force, variable_get('auto_shops_process_count', 1));
  }
  else {
    $urls = db_query("SELECT url, nid, status, authorization FROM {auto_shops} WHERE status = 'node_created' OR status = 'screen_requested' LIMIT %d", variable_get('auto_shops_process_count', 1));
  }
  
  while ($url = db_fetch_object($urls)) {
    // handle dummy screenshots
    if (strpos($url->authorization, 'unvalidated') !== FALSE) {
      $node = node_load($url->nid);
      $path = variable_get('auto_shops_dummy_screenshot', 'sites/default/files/dummy_screenshot.jpg');
    }
    else {
      $path = auto_shops_get_thumbnail($url->url);
      // drupal_set_message(print_r($path, 1)); 
    }
    if ($path == NULL) {
      $status = ($force == -1) ? 'screen_requested' : $url->status;
      db_query("UPDATE {auto_shops} SET status='%s', modified=%d WHERE url='%s'", $status, time(), $url->url);
    }
    else {
      $node = node_load($url->nid);
      $final_path = field_file_save_file($path, array(), file_directory_path() .'/stw');
      // drupal_set_message(print_r($final_path, 1));
      $node->field_screenshot[] = $final_path;
      $node = node_submit($node);
      node_save($node);
      $status = ($force == -1) ? 'screen_retrieved' : $url->status;
      db_query("UPDATE {auto_shops} SET status='%s', modified=%d WHERE url='%s'", $status, time(), $url->url);
    }
  }

  drupal_set_message('screenshot processing executed');
}

/**
 * get page from site
 * 
 * @param $force unix timestamp of date below which shops should be refreshed
 * @param $nid nid of specific shop to process
 */
function auto_shops_process_screen_retrieved($force = -1, $nid = 0) {
  if ($nid != 0) {
    $urls = db_query("SELECT url, nid, status FROM {auto_shops} WHERE nid = %d", $nid);
  }
  elseif ($force > 0) {
    $urls = db_query("SELECT url, nid, status FROM {auto_shops} WHERE status != '' AND status != 'blacklisted' AND modified <= %d ORDER BY modified ASC LIMIT %d", $force, variable_get('auto_shops_process_count', 1));
  }
  else {
    $urls = db_query("SELECT url, nid, status FROM {auto_shops} WHERE status = 'screen_retrieved' LIMIT %d", variable_get('auto_shops_process_count', 1));
  }
  
  while ($url = db_fetch_object($urls)) {
    $website_contents = auto_shops_get_url($url->url);
    // page not found, so blacklist it
    if ($website_contents === FALSE) {
      db_query("UPDATE {auto_shops} SET modified=%d, status='blacklisted' WHERE url='%s'", time(), $url->url);
      watchdog('auto_shops', 'url blacklisted because page retrieval failed for url:'. $url->url);
    }
    // failure to download
    if ($website_contents[1]['size_download'] < '50') {
      db_query("UPDATE {auto_shops} SET modified=%d WHERE url='%s'", time(), $url->url);
      watchdog('auto_shops', 'page retrieval failed for url:'. $url->url);
    }
    else {
      $node = node_load($url->nid);
      // add meta data as plain text
      $meta = auto_shops_get_meta_data($website_contents[0]);
      $node->body = $website_contents[0] .' '. $meta['description'] .' '. $meta['keywords'];
      // remove head section not processed by html filter anyways
      $node->body = substr($node->body, strpos($node->body, '</head>') + 7);
      $node = node_submit($node);
      node_save($node);
      $status = ($force == -1) ? 'page_retrieved' : $url->status;
      db_query("UPDATE {auto_shops} SET status='%s', modified=%d WHERE url='%s'", $status, time(), $url->url);
    }
  }
  
  drupal_set_message('page retrieval executed');
}

/**
 * Helper function to extract meta data
 * 
 * Borrowed from: http://www.php.net/manual/en/function.get-meta-tags.php#69003
 */
function auto_shops_get_meta_data($html) {
  preg_match_all("|<meta[^>]+name=\"([^\"]*)\"[^>]" . "+content=\"([^\"]*)\"[^>]+>|i", $html, $out, PREG_PATTERN_ORDER);

  for ($i=0;$i < count($out[1]);$i++) {
    // loop through the meta data - add your own tags here if you need
    if (strtolower($out[1][$i]) == "keywords") $meta['keywords'] = $out[2][$i];
    if (strtolower($out[1][$i]) == "description") $meta['description'] = $out[2][$i];
  }

  return $meta;   
}

/**
 * sanitize page
 * 
 * @param $force unix timestamp of date below which shops should be refreshed
 * @param $nid nid of specific shop to process
 */
function auto_shops_process_page_retrieved($force = -1, $nid = 0) {
  if ($nid != 0) {
    $urls = db_query("SELECT url, nid, status FROM {auto_shops} WHERE nid = %d", $nid);
  }
  elseif ($force > 0) {
    $urls = db_query("SELECT url, nid, status FROM {auto_shops} WHERE status != '' AND status != 'blacklisted' AND modified <= %d ORDER BY modified ASC LIMIT %d", $force, variable_get('auto_shops_process_count', 1));
  }
  else {
    $urls = db_query("SELECT url, nid, status FROM {auto_shops} WHERE status = 'page_retrieved' LIMIT %d", variable_get('auto_shops_process_count', 1));
  }
    
  while ($url = db_fetch_object($urls)) {
    $node = node_load($url->nid);
    // htmLawed currently executes on save, but could move here if performance issues arise (TODO)
    $node->body = strip_tags($node->body); // apachesolr does this anyways, so to save db room, might as well do it here first.
    $node = node_submit($node);
    node_save($node);
    $status = ($force == -1) ? 'page_sanitized' : $url->status;
    db_query("UPDATE {auto_shops} SET status='%s', modified=%d WHERE url='%s'", $status, time(), $url->url);
  }
  
  drupal_set_message('page sanitizing executed');
}

/**
 * analyze page with mo add terms
 * 
 * @param $force unix timestamp of date below which shops should be refreshed
 * @param $nid nid of specific shop to process
 */
function auto_shops_process_page_sanitized($force = -1, $nid = 0) {
  if ($nid != 0) {
    $urls = db_query("SELECT url, nid, status, authorization FROM {auto_shops} WHERE nid = %d", $nid);
  }
  elseif ($force > 0) {
    $urls = db_query("SELECT url, nid, status, authorization FROM {auto_shops} WHERE status != '' AND status != 'blacklisted' AND modified <= %d ORDER BY modified ASC LIMIT %d ", $force, variable_get('auto_shops_process_count', 1));
  }
  else {
    $urls = db_query("SELECT url, nid, status, authorization FROM {auto_shops} WHERE status = 'page_sanitized' LIMIT %d", variable_get('auto_shops_process_count', 1));
  }
  
  while ($url = db_fetch_object($urls)) {
    $node = node_load($url->nid);
    // publish the node if it is not pending
    if (strpos($url->authorization, 'pending') === FALSE) {
      $node->status = 1;
    }
    module_load_include('admin.inc', 'mo_autoaddterms');
    _mo_autoaddterms_process_node($node, TRUE);
    $node = node_submit($node);
    node_save($node);
    $status = ($force == -1) ? 'page_analyzed' : $url->status;
    db_query("UPDATE {auto_shops} SET status='%s', modified=%d WHERE url='%s'", $status, time(), $url->url);
  }
  
  drupal_set_message('page analysis executed');
}

/**
 * shrinktheweb helper function
 */ 
function auto_shops_get_thumbnail($url, $args = null, $force = false) {
  $args = $args ? $args : array('Size' => 'xlg');
  $name = md5($url.serialize($args)) .'.jpg';
  $path = variable_get('file_directory_temp', '/tmp') .'/'. $name;
  $cutoff = time() - 3600 * 24 * CACHE_DAYS;

  if ($force || !file_exists($path) || filemtime($path) <= $cutoff)
    if (($jpgurl = auto_shops_query_remote_thumbnail($url, $args)))
      if (($im = imagecreatefromjpeg($jpgurl)))
        imagejpeg($im, $path, 100);

  if (file_exists($path))
    return $path;

  return null;
}

/**
 * shrinktheweb helper function
 */
function auto_shops_query_remote_thumbnail($url, $args = null, $debug = false) {
  $args = is_array($args) ? $args : array();

  $defaults["Service"] = "ShrinkWebUrlThumbnail";
  $defaults["Action"] = "Thumbnail";
  $defaults["stwaccesskeyid"] = ACCESS_KEY;
  $defaults["stwu"] = SECRET_KEY;

  foreach ($defaults as $k=>$v)
	  if (!isset($args[$k]))
	    $args[$k] = $v;
      
	$args["stwurl"] = $url; // now url is last
		
	#$request_url = urldecode("http://www.shrinktheweb.com/xino.php?".http_build_query($args)); 
	$request_url = urldecode("http://images.shrinktheweb.com/xino.php?". http_build_query($args, '', '&'));	// avoid &amp;

  $lines = file($request_url);
  $line = implode("", $lines);
  
  if ($debug) {
    echo '<pre style=font-size:10px>';
    unset($args["stwaccesskeyid"]);
    unset($args["stwu"]);
    print_r($args);
    echo '</pre>';
    echo '<div style=font-size:10px>';
    highlight_string($line);
    echo '</div>';
  }

  $regex = '/<[^:]*:Thumbnail\\s*(?:Exists=\"((?:true)|(?:false))\")?[^>]*>([^<]*)<\//';

  if (preg_match($regex, $line, $matches) == 1 && $matches[1] == "true")
    return $matches[2];

  return null;
}

/**
 * helper function
 * 
 * Get url content and response headers (given a url, follows all redirections on it and returned content and response headers of final url)
 * Found from http://se2.php.net/manual/en/ref.curl.php#93163
 */
function auto_shops_get_url( $url,  $javascript_loop = 0, $timeout = 5 ) {
  $url = str_replace( "&amp;", "&", urldecode(trim($url)) );

	$cookie = tempnam ("/tmp", "CURLCOOKIE");
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; rv:1.7.3) Gecko/20041001 Firefox/0.10.1" );
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_COOKIEJAR, $cookie );
	curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
	curl_setopt( $ch, CURLOPT_ENCODING, "" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
	curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
	curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );    # required for https urls
	curl_setopt( $ch, CURLOPT_CONNECTTIMEOUT, $timeout );
	curl_setopt( $ch, CURLOPT_TIMEOUT, $timeout );
	curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
	
	#extra options added by Jamil
	curl_setopt( $ch, CURLOPT_HTTPHEADER, array('Accept-Encoding: gzip,deflate')); 
	#curl_setopt( $ch, CURLOPT_CRLF, true);
	#curl_setopt( $ch, CURLOPT_FAILONERROR, true);
	curl_setopt( $ch, CURLOPT_RANGE,"1-100000"); // limit to first 100k
	
	
    $content = curl_exec( $ch );
    $response = curl_getinfo( $ch );
    curl_close ( $ch );

    if ($response['http_code'] == 301 || $response['http_code'] == 302)
    {
        ini_set("user_agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; rv:1.7.3) Gecko/20041001 Firefox/0.10.1");

        if ( $headers = get_headers($response['url']) )
        {
            foreach( $headers as $value )
            {
                if ( substr( strtolower($value), 0, 9 ) == "location:" )
                    return get_url( trim( substr( $value, 9, strlen($value) ) ) );
            }
        }
    }
    else {
      return FALSE;
    }

    if (( preg_match("/>[[:space:]]+window\.location\.replace\('(.*)'\)/i", $content, $value) || preg_match("/>[[:space:]]+window\.location\=\"(.*)\"/i", $content, $value) ) && $javascript_loop < 5)
    {
      return get_url( $value[1], $javascript_loop+1 );
    }
    else
    {
      return array( $content, $response );
    }
}

function auto_shops_sync_node_table() {
  $count = 0;
  $result = db_query("SELECT n.nid FROM {node} AS n WHERE n.type='store' AND NOT EXISTS (SELECT a.nid FROM {auto_shops} AS a WHERE a.nid=n.nid)");
  while($node = db_fetch_object($result)) {
    $count++;
    node_delete($node->nid);
  }
  drupal_set_message($count .' nodes deleted');
}